Row Selection in React Gantt Chart Component

18 Nov 201824 minutes to read

The React Gantt Chart component supports row selection using mouse clicks or keyboard navigation (arrow keys). This enables users to highlight, manipulate, or trigger actions on selected task rows.

Single row selection

You can enable single row selection in the Gantt Chart component by setting selectionSettings.mode to Row and selectionSettings.type to Single. This allows you to select only one task row at a time.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {
  const taskSettings = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
  };
  const selectionSettings = {
    mode: 'Row',
    type: 'Single'
  };
  return (
    <GanttComponent
      height="370px"
      dataSource={data}
      taskFields={taskSettings}
      selectionSettings={selectionSettings}
    >
      <ColumnsDirective>
        <ColumnDirective field="TaskID" width="90" textAlign="Right" />
        <ColumnDirective field="TaskName" width="250" />
        <ColumnDirective field="StartDate" width="150" format="yMd" />
        <ColumnDirective field="Duration" width="120" textAlign="Right" />
        <ColumnDirective field="Progress" width="120" textAlign="Right" />
      </ColumnsDirective>
      <Inject services={[Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from '@syncfusion/ej2-react-gantt';
import { TaskFieldsModel, SelectionSettingsModel } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {
  const taskSettings: TaskFieldsModel = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
  };
  const selectionSettings: SelectionSettingsModel = {
    mode: 'Row',
    type: 'Single'
  };
  return (
    <GanttComponent
      height="370px"
      dataSource={data}
      taskFields={taskSettings}
      selectionSettings={selectionSettings}
    >
      <ColumnsDirective>
        <ColumnDirective field="TaskID" width="90" textAlign="Right" />
        <ColumnDirective field="TaskName" width="250" />
        <ColumnDirective field="StartDate" width="150" format="yMd" />
        <ColumnDirective field="Duration" width="120" textAlign="Right" />
        <ColumnDirective field="Progress" width="120" textAlign="Right" />
      </ColumnsDirective>
      <Inject services={[Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Multiple row selection

You can enable multiple row selection in the Gantt Chart component by setting selectionSettings.mode to Row and selectionSettings.type to Multiple. This allows selection of more than one task row at a time by holding down the Ctrl key while clicking on multiple rows.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from '@syncfusion/ej2-react-gantt';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { data } from './datasource';

function App() {
    const taskSettings = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const selectionSettings = {
        mode: 'Row',
        type: 'Multiple'
    };
    function selectRows(indexes) {
        const ganttObj = document.querySelector('#gantt').ej2_instances[0];
        ganttObj.clearSelection();
        ganttObj.selectRows(indexes);
    }
    return (
        <div>
            <div style=>
                <ButtonComponent onClick={() => selectRows([1, 3])}>Select [1, 3]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([0, 2])}>Select [0, 2]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([2, 4])}>Select [2, 4]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([0, 5])}>Select [0, 5]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([1, 6])}>Select [1, 6]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([0, 7, 2])}>Select [0, 7, 2]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([1, 6, 7])}>Select [1, 6, 7]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([4, 6, 7])}>Select [4, 6, 7]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([2, 5, 6])}>Select [2, 5, 6]</ButtonComponent>
            </div>

            <GanttComponent
                id="gantt"
                height="370px"
                dataSource={data}
                taskFields={taskSettings}
                selectionSettings={selectionSettings}
                enableHover={true}
            >
                <ColumnsDirective>
                    <ColumnDirective field="TaskID" width="90" textAlign="Right" />
                    <ColumnDirective field="TaskName" width="250" />
                    <ColumnDirective field="StartDate" width="150" format="yMd" />
                    <ColumnDirective field="Duration" width="120" textAlign="Right" />
                    <ColumnDirective field="Progress" width="120" textAlign="Right" />
                </ColumnsDirective>

                <Inject services={[Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from '@syncfusion/ej2-react-gantt';
import { TaskFieldsModel, SelectionSettingsModel } from '@syncfusion/ej2-react-gantt';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { data } from './datasource';

function App() {
    const taskSettings: TaskFieldsModel = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const selectionSettings: SelectionSettingsModel = {
        mode: 'Row',
        type: 'Multiple'
    };
    function selectRows(indexes: number[]) {
        const ganttObj: any = (document.querySelector('#gantt') as any).ej2_instances[0];
        ganttObj.clearSelection();
        ganttObj.selectRows(indexes);
    }
    return (
        <div>
            <div style=>
                <ButtonComponent onClick={() => selectRows([1, 3])}>Select [1, 3]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([0, 2])}>Select [0, 2]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([2, 4])}>Select [2, 4]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([0, 5])}>Select [0, 5]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([1, 6])}>Select [1, 6]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([0, 7, 2])}>Select [0, 7, 2]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([1, 6, 7])}>Select [1, 6, 7]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([4, 6, 7])}>Select [4, 6, 7]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([2, 5, 6])}>Select [2, 5, 6]</ButtonComponent>
            </div>

            <GanttComponent
                id="gantt"
                height="370px"
                dataSource={data}
                taskFields={taskSettings}
                selectionSettings={selectionSettings}
                enableHover={true}
            >
                <ColumnsDirective>
                    <ColumnDirective field="TaskID" width="90" textAlign="Right" />
                    <ColumnDirective field="TaskName" width="250" />
                    <ColumnDirective field="StartDate" width="150" format="yMd" />
                    <ColumnDirective field="Duration" width="120" textAlign="Right" />
                    <ColumnDirective field="Progress" width="120" textAlign="Right" />
                </ColumnsDirective>

                <Inject services={[Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Row selection event sequence

  • On initial row selection: rowSelecting triggers first, followed by rowSelected.

  • When selecting a different row:

This sequence ensures proper handling of row transitions during selection and deselection.

Select row at initial rendering

You can highlight or pre-select a specific row during the initial rendering of the Gantt Chart component by setting the selectedRowIndex property. This selects the row at the specified index when the Gantt loads.

The following example selects the row at index 5 during initial load:

import * as React from 'react'; import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {

  const taskSettings = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
  };

  const selectionSettings = {
    mode: 'Row',
    type: 'Multiple'
  };

  return (
    <GanttComponent
      height="370px"
      dataSource={data}
      selectedRowIndex={5}
      taskFields={taskSettings}
      selectionSettings={selectionSettings}
    >
      <ColumnsDirective>
        <ColumnDirective field="TaskID" width="90" textAlign="Right" />
        <ColumnDirective field="TaskName" width="250" />
        <ColumnDirective field="StartDate" width="150" format="yMd" />
        <ColumnDirective field="Duration" width="120" textAlign="Right" />
        <ColumnDirective field="Progress" width="120" textAlign="Right" />
      </ColumnsDirective>

      <Inject services={[Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react'; import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from '@syncfusion/ej2-react-gantt';
import { TaskFieldsModel, SelectionSettingsModel } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {

  const taskSettings: TaskFieldsModel = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    parentID: 'ParentID'
  };

  const selectionSettings: SelectionSettingsModel = {
    mode: 'Row',
    type: 'Multiple'
  };

  return (
    <GanttComponent
      height="370px"
      dataSource={data}
      selectedRowIndex={5}
      taskFields={taskSettings}
      selectionSettings={selectionSettings}
    >
      <ColumnsDirective>
        <ColumnDirective field="TaskID" width="90" textAlign="Right" />
        <ColumnDirective field="TaskName" width="250" />
        <ColumnDirective field="StartDate" width="150" format="yMd" />
        <ColumnDirective field="Duration" width="120" textAlign="Right" />
        <ColumnDirective field="Progress" width="120" textAlign="Right" />
      </ColumnsDirective>

      <Inject services={[Selection]} />
    </GanttComponent>
  );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Select rows externally

You can programmatically or dynamically select single rows, multiple rows, or a range of rows in the React Gantt Chart component.

Single row selection

Select a single row in the Gantt Chart component by calling the selectRow method with the desired row index.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from '@syncfusion/ej2-react-gantt';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { data } from './datasource';

function App() {
  let textBoxObj = null;
  const taskSettings = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
  };
  const selectionSettings = {
    mode: 'Row',
    type: 'Single'
  };
  function clickHandler() {
    if (textBoxObj) {
      const value = textBoxObj.value;
      const index = parseInt(value, 10);
      if (!isNaN(index)) {
        const ganttObj = document.querySelector('#gantt').ej2_instances[0];
        ganttObj.selectRow(index);
      }
    }
  }
  return (
    <div>
      <div style=>
        <label style=>Enter the row index:</label>
        <TextBoxComponent width="100" ref={(scope) => { textBoxObj = scope; }} />
        <ButtonComponent onClick={clickHandler}>Select Row</ButtonComponent>
      </div>
      <GanttComponent
        id="gantt"
        height="370px"
        dataSource={data}
        taskFields={taskSettings}
        selectionSettings={selectionSettings}
      >
        <ColumnsDirective>
          <ColumnDirective field="TaskID" width="90" textAlign="Right" />
          <ColumnDirective field="TaskName" width="200" />
          <ColumnDirective field="StartDate" width="120" format="yMd" />
          <ColumnDirective field="Duration" width="120" textAlign="Right" />
          <ColumnDirective field="Progress" width="120" textAlign="Right" />
        </ColumnsDirective>
        <Inject services={[Selection]} />
      </GanttComponent>
    </div>
  );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from '@syncfusion/ej2-react-gantt';
import { TaskFieldsModel, SelectionSettingsModel } from '@syncfusion/ej2-react-gantt';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { data } from './datasource';

function App() {
  let textBoxObj: any = null;
  const taskSettings: TaskFieldsModel = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
  };
  const selectionSettings: SelectionSettingsModel = {
    mode: 'Row',
    type: 'Single'
  };
  function clickHandler() {
    if (textBoxObj) {
      const value = textBoxObj.value;
      const index = parseInt(value, 10);
      if (!isNaN(index)) {
        const ganttObj: any = (document.querySelector('#gantt') as any).ej2_instances[0];
        ganttObj.selectRow(index);
      }
    }
  }
  return (
    <div>
      <div style=>
        <label style=>Enter the row index:</label>
        <TextBoxComponent
          width="100"
          ref={(scope) => { textBoxObj = scope; }}
        />
        <ButtonComponent onClick={clickHandler}>Select Row</ButtonComponent>
      </div>
      <GanttComponent
        id="gantt"
        height="370px"
        dataSource={data}
        taskFields={taskSettings}
        selectionSettings={selectionSettings}
      >
        <ColumnsDirective>
          <ColumnDirective field="TaskID" width="90" textAlign="Right" />
          <ColumnDirective field="TaskName" width="200" />
          <ColumnDirective field="StartDate" width="120" format="yMd" />
          <ColumnDirective field="Duration" width="120" textAlign="Right" />
          <ColumnDirective field="Progress" width="120" textAlign="Right" />
        </ColumnsDirective>
        <Inject services={[Selection]} />
      </GanttComponent>
    </div>
  );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Multiple rows selection

Select multiple rows in the Gantt Chart component by using the selectRows method with an array of row indexes.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from '@syncfusion/ej2-react-gantt';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { data } from './datasource';

function App() {
    const taskSettings = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const selectionSettings = {
        mode: 'Row',
        type: 'Multiple'
    };
    function selectRows(indexes) {
        const ganttObj = document.querySelector('#gantt').ej2_instances[0];
        ganttObj.clearSelection();
        ganttObj.selectRows(indexes);
    }
    return (
        <div>
            <div style=>
                <ButtonComponent onClick={() => selectRows([1, 3])}>Select [1, 3]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([0, 2])}>Select [0, 2]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([2, 4])}>Select [2, 4]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([0, 5])}>Select [0, 5]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([1, 6])}>Select [1, 6]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([0, 7, 2])}>Select [0, 7, 2]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([1, 6, 7])}>Select [1, 6, 7]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([4, 6, 7])}>Select [4, 6, 7]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([2, 5, 6])}>Select [2, 5, 6]</ButtonComponent>
            </div>

            <GanttComponent
                id="gantt"
                height="370px"
                dataSource={data}
                taskFields={taskSettings}
                selectionSettings={selectionSettings}
                enableHover={true}
            >
                <ColumnsDirective>
                    <ColumnDirective field="TaskID" width="90" textAlign="Right" />
                    <ColumnDirective field="TaskName" width="250" />
                    <ColumnDirective field="StartDate" width="150" format="yMd" />
                    <ColumnDirective field="Duration" width="120" textAlign="Right" />
                    <ColumnDirective field="Progress" width="120" textAlign="Right" />
                </ColumnsDirective>

                <Inject services={[Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from '@syncfusion/ej2-react-gantt';
import { TaskFieldsModel, SelectionSettingsModel } from '@syncfusion/ej2-react-gantt';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { data } from './datasource';

function App() {
    const taskSettings: TaskFieldsModel = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const selectionSettings: SelectionSettingsModel = {
        mode: 'Row',
        type: 'Multiple'
    };
    function selectRows(indexes: number[]) {
        const ganttObj: any = (document.querySelector('#gantt') as any).ej2_instances[0];
        ganttObj.clearSelection();
        ganttObj.selectRows(indexes);
    }
    return (
        <div>
            <div style=>
                <ButtonComponent onClick={() => selectRows([1, 3])}>Select [1, 3]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([0, 2])}>Select [0, 2]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([2, 4])}>Select [2, 4]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([0, 5])}>Select [0, 5]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([1, 6])}>Select [1, 6]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([0, 7, 2])}>Select [0, 7, 2]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([1, 6, 7])}>Select [1, 6, 7]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([4, 6, 7])}>Select [4, 6, 7]</ButtonComponent>
                <ButtonComponent onClick={() => selectRows([2, 5, 6])}>Select [2, 5, 6]</ButtonComponent>
            </div>

            <GanttComponent
                id="gantt"
                height="370px"
                dataSource={data}
                taskFields={taskSettings}
                selectionSettings={selectionSettings}
                enableHover={true}
            >
                <ColumnsDirective>
                    <ColumnDirective field="TaskID" width="90" textAlign="Right" />
                    <ColumnDirective field="TaskName" width="250" />
                    <ColumnDirective field="StartDate" width="150" format="yMd" />
                    <ColumnDirective field="Duration" width="120" textAlign="Right" />
                    <ColumnDirective field="Progress" width="120" textAlign="Right" />
                </ColumnsDirective>

                <Inject services={[Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Range of rows selection

Select a range of rows in the Gantt Chart component by using the selectRowsByRange method with the start and end row indexes.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from '@syncfusion/ej2-react-gantt';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { data } from './datasource';

function App() {
    let startObj = null;
    let endObj = null;
    const taskSettings = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const selectionSettings = {
        mode: 'Row',
        type: 'Multiple'
    };
    function selectRowRange() {
        const start = parseInt(startObj.value, 10);
        const end = parseInt(endObj.value, 10);

        if (!isNaN(start) && !isNaN(end) && start >= 0 && end >= start) {
            const ganttObj = document.querySelector('#gantt').ej2_instances[0];
            ganttObj.clearSelection();
            ganttObj.selectionModule.selectRowsByRange(start, end);
        }
    }
    return (
        <div>
            <div style=>
                <label style=>Start Row Index:</label>
                <TextBoxComponent width="120" type="number" ref={(scope) => { startObj = scope; }} />
                <label style=>End Row Index:</label>
                <TextBoxComponent width="120" type="number" ref={(scope) => { endObj = scope; }} />
                <ButtonComponent onClick={selectRowRange}>Select Rows</ButtonComponent>
            </div>
            <GanttComponent
                id="gantt"
                height="370px"
                dataSource={data}
                taskFields={taskSettings}
                selectionSettings={selectionSettings}
                enableHover={true}
            >
                <ColumnsDirective>
                    <ColumnDirective field="TaskID" width="90" textAlign="Right" />
                    <ColumnDirective field="TaskName" width="220" />
                    <ColumnDirective field="StartDate" width="150" format="yMd" />
                    <ColumnDirective field="Duration" width="120" textAlign="Right" />
                    <ColumnDirective field="Progress" width="120" textAlign="Right" />
                </ColumnsDirective>
                <Inject services={[Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, ColumnsDirective, ColumnDirective, Inject, Selection } from '@syncfusion/ej2-react-gantt';
import { TaskFieldsModel, SelectionSettingsModel } from '@syncfusion/ej2-react-gantt';
import { TextBoxComponent } from '@syncfusion/ej2-react-inputs';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { data } from './datasource';

function App() {
    let startObj: any = null;
    let endObj: any = null;
    const taskSettings: TaskFieldsModel = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const selectionSettings: SelectionSettingsModel = {
        mode: 'Row',
        type: 'Multiple'
    };
    function selectRowRange() {
        const start = parseInt(startObj.value, 10);
        const end = parseInt(endObj.value, 10);

        if (!isNaN(start) && !isNaN(end) && start >= 0 && end >= start) {
            const ganttObj: any = (document.querySelector('#gantt') as any).ej2_instances[0];
            ganttObj.clearSelection();
            ganttObj.selectionModule.selectRowsByRange(start, end);
        }
    }
    return (
        <div>
            <div style=>
                <label style=>Start Row Index:</label>
                <TextBoxComponent width="120" type="number" ref={(scope) => { startObj = scope; }} />
                <label style=>End Row Index:</label>
                <TextBoxComponent width="120" type="number" ref={(scope) => { endObj = scope; }} />
                <ButtonComponent onClick={selectRowRange}>Select Rows</ButtonComponent>
            </div>
            <GanttComponent
                id="gantt"
                height="370px"
                dataSource={data}
                taskFields={taskSettings}
                selectionSettings={selectionSettings}
                enableHover={true}
            >
                <ColumnsDirective>
                    <ColumnDirective field="TaskID" width="90" textAlign="Right" />
                    <ColumnDirective field="TaskName" width="220" />
                    <ColumnDirective field="StartDate" width="150" format="yMd" />
                    <ColumnDirective field="Duration" width="120" textAlign="Right" />
                    <ColumnDirective field="Progress" width="120" textAlign="Right" />
                </ColumnsDirective>
                <Inject services={[Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Enable multi row selection without Ctrl key

You can enable simple multi-row selection by setting the enableSimpleMultiRowSelection property to true in the Grid configuration during the created event. This allows multiple rows to be selected individually through clicks without holding the Ctrl key.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {
    const taskFields = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        endDate: 'EndDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const selectionSettings = {
        mode: 'Row',
        type: 'Multiple'
    };
    function created(args) {
        const gantt = document.getElementById('ganttDefault').ej2_instances[0];
        if (gantt) {
            gantt.treeGrid.grid.selectionSettings.enableSimpleMultiRowSelection = false;
        }
    }
    return (
        <GanttComponent
            id="ganttDefault"
            height="450px"
            dataSource={data}
            taskFields={taskFields}
            selectionSettings={selectionSettings}
            created={created}>
        </GanttComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, TaskFieldsModel, SelectionSettingsModel } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {
    const taskFields: TaskFieldsModel = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        endDate: 'EndDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const selectionSettings: SelectionSettingsModel = {
        mode: 'Row',
        type: 'Multiple'
    };
    function created(args: object): void {
        const gantt: any = (document.getElementById('ganttDefault') as any).ej2_instances[0];
        if (gantt) {
            gantt.treeGrid.grid.selectionSettings.enableSimpleMultiRowSelection = false;
        }
    }
    return (
        <GanttComponent
            id="ganttDefault"
            height="450px"
            dataSource={data}
            taskFields={taskFields}
            selectionSettings={selectionSettings}
            created={created}>
        </GanttComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Get selected row information

To access selected row details in the React Gantt Chart component:

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Selection, SelectionSettingsModel, TaskFieldsModel } from '@syncfusion/ej2-react-gantt';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { data } from './datasource';

let ganttInstance = null;
let selectedRecords= [];

function renderApp() {
  const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
  };

  const selectionSettings = {
    mode: 'Row',
    type: 'Multiple'
  };

  function getSelectedRowInfo() {
    if (!ganttInstance) return;
    selectedRecords = ganttInstance.selectionModule.getSelectedRecords();
    const selectedRows = ganttInstance.selectionModule.getSelectedRows();
    selectedRows.forEach(row => row.classList.add('custom-selected-row'));
    renderApp();
  }

  const App = () => (
    <div>
      <div className="button-container">
        <ButtonComponent cssClass="action-button" onClick={getSelectedRowInfo}>
          Show Selected Tasks
        </ButtonComponent>
      </div>

      <div className="table-container">
        {selectedRecords.length > 0 && (
          <table className="task-table">
            <thead>
              <tr>
                <th>Index</th>
                <th>Task Details</th>
              </tr>
            </thead>
            <tbody>
              {selectedRecords.map((record, i) => (
                <tr key={record.TaskID} className={i % 2 !== 0 ? 'alternate-row' : 'selected-row'}>
                  <td>{i + 1}</td>
                  <td>
                    <div><strong>Task ID:</strong> {record.TaskID}</div>
                    <div><strong>Task Name:</strong> {record.TaskName}</div>
                    <div><strong>Start Date:</strong> {record.StartDate && record.StartDate.toDateString()}</div>
                    <div><strong>Duration:</strong> {record.Duration}</div>
                    <div><strong>Progress:</strong> {record.Progress}%</div>
                  </td>
                </tr>
              ))}
            </tbody>
          </table>
        )}
      </div>

      <GanttComponent
        ref={(g) => (ganttInstance = g)}
        dataSource={data}
        taskFields={taskFields}
        selectionSettings={selectionSettings}
        height="430px"
      >
        <Inject services={[Selection]} />
      </GanttComponent>
    </div>
  );

  ReactDOM.render(<App />, document.getElementById('root'));
}

renderApp();
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Selection, SelectionSettingsModel, TaskFieldsModel } from '@syncfusion/ej2-react-gantt';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { data } from './datasource';

interface Task {
  TaskID: number;
  TaskName: string;
  StartDate: Date;
  EndDate?: Date;
  Duration?: number;
  Progress?: number;
  ParentID?: number;
}

let ganttInstance: GanttComponent | null = null;
let selectedRecords: Task[] = [];

function renderApp() {
  const taskFields: TaskFieldsModel = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    parentID: 'ParentID'
  };

  const selectionSettings: SelectionSettingsModel = {
    mode: 'Row',
    type: 'Multiple'
  };

  function getSelectedRowInfo() {
    if (!ganttInstance) return;
    selectedRecords = ganttInstance.selectionModule.getSelectedRecords() as Task[];
    const selectedRows = ganttInstance.selectionModule.getSelectedRows() as HTMLElement[];
    selectedRows.forEach(row => row.classList.add('custom-selected-row'));
    renderApp();
  }

  const App = () => (
    <div>
      <div className="button-container">
        <ButtonComponent cssClass="action-button" onClick={getSelectedRowInfo}>
          Show Selected Tasks
        </ButtonComponent>
      </div>

      <div className="table-container">
        {selectedRecords.length > 0 && (
          <table className="task-table">
            <thead>
              <tr>
                <th>Index</th>
                <th>Task Details</th>
              </tr>
            </thead>
            <tbody>
              {selectedRecords.map((record: Task, i: number) => (
                <tr key={record.TaskID} className={i % 2 !== 0 ? 'alternate-row' : 'selected-row'}>
                  <td>{i + 1}</td>
                  <td>
                    <div><strong>Task ID:</strong> {record.TaskID}</div>
                    <div><strong>Task Name:</strong> {record.TaskName}</div>
                    <div><strong>Start Date:</strong> {record.StartDate && record.StartDate.toDateString()}</div>
                    <div><strong>Duration:</strong> {record.Duration}</div>
                    <div><strong>Progress:</strong> {record.Progress}%</div>
                  </td>
                </tr>
              ))}
            </tbody>
          </table>
        )}
      </div>

      <GanttComponent
        ref={(g) => (ganttInstance = g)}
        dataSource={data}
        taskFields={taskFields}
        selectionSettings={selectionSettings}
        height="430px"
      >
        <Inject services={[Selection]} />
      </GanttComponent>
    </div>
  );

  ReactDOM.render(<App />, document.getElementById('root'));
}

renderApp();
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }

        .button-container {
            padding: 20px 0;
        }

        .action-button {
            background: linear-gradient(90deg, #1e3a8a, #3b82f6);
            color: #ffffff;
            padding: 12px 24px;
            border: none;
            border-radius: 6px;
            font-size: 14px;
            font-weight: 600;
            cursor: pointer;
            transition: all 0.3s ease;
            box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
        }

        .action-button:hover {
            background: linear-gradient(90deg, #1e40af, #60a5fa);
            transform: scale(1.05);
        }

        .action-button:active {
            transform: scale(0.95);
            box-shadow: 0 1px 2px rgba(0, 0, 0, 0.2);
        }

        .action-button:focus {
            outline: none;
            box-shadow: 0 0 0 3px rgba(59, 130, 246, 0.3);
        }

        .table-container {
            display: flex;
            justify-content: center;
            margin-bottom: 20px;
        }

        .task-table {
            border-collapse: collapse;
            width: 80%;
            max-width: 900px;
            font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
            box-shadow: 0 2px 8px rgba(0, 0, 0, 0.1);
        }

        .task-table th,
        .task-table td {
            padding: 12px 16px;
            text-align: left;
            border: 1px solid #e5e7eb;
        }

        .task-table th {
            background: #f3f4f6;
            font-weight: 600;
            color: #1f2937;
        }

        .selected-row {
            background: #eff6ff;
            transition: background 0.2s ease;
        }

        .alternate-row {
            background: #f9fafb;
        }

        .task-table td div {
            margin-bottom: 6px;
            color: #1f2937;
        }

        .e-gantt .e-grid .custom-selected-row .e-selectionbackground {
            background-color: #d1e7dd !important;
        }
    </style>
</head>

<body>
    <div id='root'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Note: The Gantt Chart component supports keyboard navigation for row selection. Use arrow keys to move focus and Enter or Space to select rows. Ensure accessibility compliance by providing appropriate ARIA attributes.

Customize row selection action

You can customize row selection in the Gantt Chart using rowSelecting, rowSelected, rowDeselecting, and rowDeselected events, which allow dynamic control over selection behavior based on specific conditions.

The following demonstrates how row selection and background color updates are handled in the React Gantt Chart component:

  • In rowSelecting, selection is prevented when TaskID is 2.
  • In rowSelected, rows with Progress > 40 are highlighted with a green background.
  • In rowDeselected, rows with Progress ≤ 40 are styled with mauve background color.
  • In rowDeselecting, if Progress > 80, the background color changes to yellow.

The following sample demonstrates

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Selection, Inject, Edit } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {
    const taskFields = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        endDate: 'EndDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const selectionSettings = {
        mode: 'Row',
        type: 'Multiple'
    };
    let message = "";
    function updateMessage() {
        const el = document.getElementById("message");
        if (el) el.innerHTML = message;
    }
    function rowSelecting(args) {
        const task = args.data;
        if (task.TaskID === 2) {
            args.cancel = true;
            message += " - Selection cancelled for TaskID 2";
            updateMessage();
        }
    }
    function rowSelected(args) {
        const task = args.data;
        if (task.Progress && task.Progress > 40) {
            args.row.style.backgroundColor = "rgba(203, 246, 205, 1)";
        }
    }
    function rowDeselected(args) {
        if (args.data && !Array.isArray(args.data)) {
            const task = args.data;
            if (task.Progress && task.Progress <= 40) {
                args.row.style.backgroundColor = "#e1838eff";
            }
        }
    }
    function rowDeselecting(args) {
        if (args.data && !Array.isArray(args.data)) {
            const task = args.data;
            if (task.Progress && task.Progress > 80) {
                args.row.style.backgroundColor = "#f5f54bff";
            }
        }
    }
    return (
        <div>
            <p id="message"></p>
            <GanttComponent
                id="ganttDefault"
                height="370px"
                dataSource={data}
                taskFields={taskFields}
                rowSelecting={rowSelecting}
                rowSelected={rowSelected}
                rowDeselected={rowDeselected}
                rowDeselecting={rowDeselecting}
                selectionSettings={selectionSettings}
                enableHover={false}
            >
                <Inject services={[Edit, Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, RowSelectEventArgs, RowSelectingEventArgs, RowDeselectEventArgs, TaskFieldsModel, SelectionSettingsModel, Selection, Inject, Edit } from '@syncfusion/ej2-react-gantt';
import { data } from './datasource';

function App() {
    const taskFields: TaskFieldsModel = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        endDate: 'EndDate',
        duration: 'Duration',
        progress: 'Progress',
        parentID: 'ParentID'
    };
    const selectionSettings: SelectionSettingsModel = {
        mode: 'Row',
        type: 'Multiple'
    };
    let message = "";
    function updateMessage() {
        const el = document.getElementById("message");
        if (el) el.innerHTML = message;
    }
    function rowSelecting(args: RowSelectingEventArgs): void {
        const task: any = args.data;
        if (task.TaskID === 2) {
            args.cancel = true;
            message += " - Selection cancelled for TaskID 2";
            updateMessage();
        }
    }
    function rowSelected(args: RowSelectEventArgs): void {
        const task: any = args.data;
        if (task.Progress && task.Progress > 40) {
            (args.row as HTMLElement).style.backgroundColor = "rgba(203, 246, 205, 1)";
        }
    }
    function rowDeselected(args: RowDeselectEventArgs): void {
        if (args.data && !Array.isArray(args.data)) {
            const task: any = args.data;
            if (task.Progress && task.Progress <= 40) {
                (args.row as HTMLElement).style.backgroundColor = "#e1838eff";
            }
        }
    }
    function rowDeselecting(args: RowDeselectEventArgs): void {
        if (args.data && !Array.isArray(args.data)) {
            const task: any = args.data;
            if (task.Progress && task.Progress > 80) {
                (args.row as HTMLElement).style.backgroundColor = "#f5f54bff";
            }
        }
    }
    return (
        <div>
            <p id="message"></p>
            <GanttComponent
                id="ganttDefault"
                height="370px"
                dataSource={data}
                taskFields={taskFields}
                rowSelecting={rowSelecting}
                rowSelected={rowSelected}
                rowDeselected={rowDeselected}
                rowDeselecting={rowDeselecting}
                selectionSettings={selectionSettings}
                enableHover={false}
            >
                <Inject services={[Edit, Selection]} />
            </GanttComponent>
        </div>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css"/>
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
     <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
        <div id='root'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Row selection in Angular Gantt Chart component

18 Nov 201824 minutes to read

The Angular Gantt Chart component supports row selection using mouse clicks or keyboard navigation (arrow keys). This enables users to highlight, manipulate, or trigger actions on selected task rows.

Single row selection

You can enable single row selection in the Gantt Chart component by setting selectionSettings.mode to Row and selectionSettings.type to Single. This allows you to select only one task row at a time.

import { Component, OnInit, ViewEncapsulation } from '@angular/core';
import { GanttModule, SelectionService } from '@syncfusion/ej2-angular-gantt';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';

@Component({
  standalone: true,
  selector: 'app-root',
  imports: [GanttModule],
  providers: [SelectionService],
  template: `
    <ejs-gantt height="370px" [dataSource]="data" [taskFields]="taskSettings" [selectionSettings]="selectionSettings">
    </ejs-gantt>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};

  ngOnInit(): void {
    this.data = [
      {
        TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'),
      },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      {
        TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'),
      },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      endDate: 'EndDate',
      duration: 'Duration',
      progress: 'Progress',
      dependency: 'Predecessor',
      parentID: 'ParentID'
    };
    this.selectionSettings = {
      mode: 'Row',
      type: 'Single'
    };
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Multiple row selection

You can enable multiple row selection in the Gantt Chart component by setting selectionSettings.mode to Row and selectionSettings.type to Multiple. This allows selection of more than one task row at a time by holding down the Ctrl key while clicking on multiple rows.

import { Component, OnInit, ViewEncapsulation } from '@angular/core';
import { GanttModule, SelectionService } from '@syncfusion/ej2-angular-gantt';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';

@Component({
  standalone: true,
  selector: 'app-root',
  imports: [GanttModule],
  providers: [SelectionService],
  template: `
    <ejs-gantt height="370px" [dataSource]="data" [taskFields]="taskSettings" [selectionSettings]="selectionSettings">
    </ejs-gantt>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};

  ngOnInit(): void {
    this.data = [
      {
        TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'),
      },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      {
        TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'),
      },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      endDate: 'EndDate',
      duration: 'Duration',
      progress: 'Progress',
      dependency: 'Predecessor',
      parentID: 'ParentID'
    };
    this.selectionSettings = {
      mode: 'Row',
      type: 'Multiple'
    };
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Row selection event sequence

  • On initial row selection: rowSelecting triggers first, followed by rowSelected.

  • When selecting a different row:

This sequence ensures proper handling of row transitions during selection and deselection.

Select row at initial rendering

You can highlight or pre-select a specific row during the initial rendering of the Gantt Chart component by setting the selectedRowIndex property. This selects the row at the specified index when the Gantt loads.

The following example selects the row at index 5 during initial load:

import { Component, OnInit, ViewEncapsulation } from '@angular/core';
import { GanttModule, SelectionService } from '@syncfusion/ej2-angular-gantt';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';

@Component({
  standalone: true,
  selector: 'app-root',
  imports: [GanttModule],
  providers: [SelectionService],
  template: `
    <ejs-gantt height="370px" [dataSource]="data" [selectedRowIndex] = '5' [taskFields]="taskSettings" [selectionSettings]="selectionSettings">
    </ejs-gantt>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};

  ngOnInit(): void {
    this.data = [
      {
        TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'),
      },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      {
        TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'),
      },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      endDate: 'EndDate',
      duration: 'Duration',
      progress: 'Progress',
      dependency: 'Predecessor',
      parentID: 'ParentID'
    };
    this.selectionSettings = {
      mode: 'Row',
      type: 'Multiple'
    };
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

You can also select single or multiple rows during the initial load by using the selectRow or selectRows method inside the dataBound event.

Select rows externally

You can programmatically or dynamically select single rows, multiple rows, or a range of rows in the Angular Gantt Chart component.

Single row selection

Select a single row in the Gantt Chart component by calling the selectRow method with the desired row index.

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { GanttComponent, GanttModule, SelectionService } from '@syncfusion/ej2-angular-gantt';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';
import { TextBoxComponent, TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
    standalone: true,
    selector: 'app-root',
    imports: [GanttModule, TextBoxModule, ButtonModule],
    providers: [SelectionService],
    template: `  
        <div style="display: flex; align-items: center; gap: 10px; margin-bottom: 10px;">
            <label style="font-weight: bold;">Enter the row index:</label>
            <ejs-textbox #textbox width="100"></ejs-textbox>
            <button ejs-button (click)="click()">Select Row</button>
        </div>
        <ejs-gantt #gantt height="370px" [dataSource]="data" [taskFields]="taskSettings" [selectionSettings]="selectionSettings">
        </ejs-gantt>`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
    @ViewChild('gantt', { static: true }) public ganttInstance!: GanttComponent;
    @ViewChild('textbox', { static: false }) public textbox?: TextBoxComponent;
    public data: object[] = [];
    public taskSettings: object = {};
    public selectionSettings: SelectionSettingsModel = {};

    ngOnInit(): void {
        this.data = [
            { TaskID: 1, TaskName: 'Initiation Phase', StartDate: new Date('2023-04-01'), Duration: 5, Progress: 40 },
            { TaskID: 2, TaskName: 'Site Survey', StartDate: new Date('2023-04-06'), Duration: 4, ParentID: 1, Progress: 60 },
            { TaskID: 3, TaskName: 'Soil Testing', StartDate: new Date('2023-04-10'), Duration: 4, ParentID: 1, Progress: 50 },
            { TaskID: 4, TaskName: 'Approval Process', StartDate: new Date('2023-04-14'), Duration: 3, ParentID: 1, Progress: 30 },
            { TaskID: 5, TaskName: 'Estimation Phase', StartDate: new Date('2023-04-18'), Duration: 6, Progress: 20 },
            { TaskID: 6, TaskName: 'Floor Plan Design', StartDate: new Date('2023-04-24'), Duration: 3, ParentID: 5, Progress: 50 },
            { TaskID: 7, TaskName: 'Material Listing', StartDate: new Date('2023-04-27'), Duration: 3, ParentID: 5, Progress: 50 },
            { TaskID: 8, TaskName: 'Final Approval', StartDate: new Date('2023-04-30'), Duration: 2, ParentID: 5, Progress: 50 }
        ];
        this.taskSettings = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            progress: 'Progress',
            parentID: 'ParentID'
        };
        this.selectionSettings = {
            mode: 'Row',
            type: 'Single'
        };
    }

    public click(): void {
        const value = (this.textbox as TextBoxComponent).element.value as string;
        const rowIndex = parseInt(value, 10);
        if (!isNaN(rowIndex)) {
            this.ganttInstance.selectRow(rowIndex);
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Multiple rows selection

Select multiple rows in the Gantt Chart component by using the selectRows method with an array of row indexes.

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { GanttComponent, GanttModule, SelectionService } from '@syncfusion/ej2-angular-gantt';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
  standalone: true,
  selector: 'app-root',
  imports: [GanttModule, ButtonModule],
  providers: [SelectionService],
  template: `
    <div style="display: flex; flex-wrap: wrap; gap: 10px; padding: 10px 0 20px 0;">
      <button ejs-button (click)="selectRows([1, 3])">Select [1, 3]</button>
      <button ejs-button (click)="selectRows([0, 2])">Select [0, 2]</button>
      <button ejs-button (click)="selectRows([2, 4])">Select [2, 4]</button>
      <button ejs-button (click)="selectRows([0, 5])">Select [0, 5]</button>
      <button ejs-button (click)="selectRows([1, 6])">Select [1, 6]</button>
      <button ejs-button (click)="selectRows([0, 7, 2])">Select [0, 7, 2]</button>
      <button ejs-button (click)="selectRows([1, 6, 7])">Select [1, 6, 7]</button>
      <button ejs-button (click)="selectRows([4, 6, 7])">Select [4, 6, 7]</button>
      <button ejs-button (click)="selectRows([2, 5, 6])">Select [2, 5, 6]</button>
    </div>
    <ejs-gantt #gantt height="370px" [dataSource]="data" [taskFields]="taskSettings" [selectionSettings]="selectionSettings" enableHover="true">
    </ejs-gantt>`,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
  @ViewChild('gantt', { static: true }) public ganttInstance!: GanttComponent;
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Kickoff', StartDate: new Date('2023-04-01'), Duration: 5, Progress: 40 },
      { TaskID: 2, TaskName: 'Requirement Gathering', StartDate: new Date('2023-04-06'), Duration: 4, ParentID: 1, Progress: 60 },
      { TaskID: 3, TaskName: 'Feasibility Study', StartDate: new Date('2023-04-10'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Initial Approval', StartDate: new Date('2023-04-14'), Duration: 3, ParentID: 1, Progress: 30 },
      { TaskID: 5, TaskName: 'Design Phase', StartDate: new Date('2023-04-18'), Duration: 6, Progress: 20 },
      { TaskID: 6, TaskName: 'UI/UX Design', StartDate: new Date('2023-04-24'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'Architecture Planning', StartDate: new Date('2023-04-27'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Final Review', StartDate: new Date('2023-04-30'), Duration: 2, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
    this.selectionSettings = {
      mode: 'Row',
      type: 'Multiple'
    };
  }

  public selectRows(rowIndexes: number[]): void {
    this.ganttInstance.clearSelection();
    this.ganttInstance.selectRows(rowIndexes);
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Range of rows selection

Select a range of rows in the Gantt Chart component by using the selectRowsByRange method with the start and end row indexes.

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { GanttComponent, GanttModule, SelectionService } from '@syncfusion/ej2-angular-gantt';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';
import { TextBoxComponent, TextBoxModule } from '@syncfusion/ej2-angular-inputs';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
  standalone: true,
  selector: 'app-root',
  imports: [GanttModule, TextBoxModule, ButtonModule],
  providers: [SelectionService],
  template: `
    <div style="display: flex; align-items: center; gap: 10px; padding: 20px 0;">
      <label style="font-weight: bold;">Start Row Index:</label>
      <ejs-textbox #startTextbox type="number" width="120"></ejs-textbox>
      <label style="font-weight: bold;">End Row Index:</label>
      <ejs-textbox #endTextbox type="number" width="120"></ejs-textbox>
      <button ejs-button (click)="selectRowRange()">Select Rows</button>
    </div>
    <ejs-gantt #gantt height="370px" [dataSource]="data" [taskFields]="taskSettings" [selectionSettings]="selectionSettings" enableHover="true">
    </ejs-gantt>
  `,
  encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
  @ViewChild('gantt', { static: true }) public ganttInstance!: GanttComponent;
  @ViewChild('startTextbox') public startTextbox!: TextBoxComponent;
  @ViewChild('endTextbox') public endTextbox!: TextBoxComponent;
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Planning', StartDate: new Date('2023-04-01'), Duration: 5, Progress: 40 },
      { TaskID: 2, TaskName: 'Requirement Analysis', StartDate: new Date('2023-04-06'), Duration: 4, ParentID: 1, Progress: 60 },
      { TaskID: 3, TaskName: 'Design', StartDate: new Date('2023-04-10'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Development', StartDate: new Date('2023-04-14'), Duration: 3, ParentID: 1, Progress: 30 },
      { TaskID: 5, TaskName: 'Testing', StartDate: new Date('2023-04-18'), Duration: 6, Progress: 20 },
      { TaskID: 6, TaskName: 'Deployment', StartDate: new Date('2023-04-24'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'Maintenance', StartDate: new Date('2023-04-27'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Closure', StartDate: new Date('2023-04-30'), Duration: 2, ParentID: 5, Progress: 50 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
    this.selectionSettings = {
      mode: 'Row',
      type: 'Multiple'
    };
  }

  public selectRowRange(): void {
    const start = parseInt(this.startTextbox.element.value, 10);
    const end = parseInt(this.endTextbox.element.value, 10);
    if (!isNaN(start) && !isNaN(end) && start >= 0 && end >= start) {
      this.ganttInstance.clearSelection();
      this.ganttInstance.selectionModule.selectRowsByRange(start, end);
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Enable multi row selection without Ctrl key

You can enable simple multi-row selection by setting the enableSimpleMultiRowSelection property to true in the Grid configuration during the created event. This allows multiple rows to be selected individually through clicks without holding the Ctrl key.

import { Component, OnInit, ViewChild} from '@angular/core';
import { editingData } from './data';
import { GanttAllModule,GanttComponent } from '@syncfusion/ej2-angular-gantt';

@Component({
    imports: [ GanttAllModule],
    standalone: true,
    selector: 'app-root',
    template: ` 
    <ejs-gantt #gantt id="ganttDefault" height="430px" [dataSource]="data" [taskFields]="taskSettings" [columns]="columns"
    height="450px" [allowSelection]="true"  [selectionSettings]="selectionSettings" (created)="created($event)">
    </ejs-gantt>`
})
export class AppComponent implements OnInit{
    @ViewChild('gantt', {static: true})
    public ganttObj?: GanttComponent| any;
    public data?: object[];
    public taskSettings?: object;
    public columns?: object[];
    public startDate? :object;
    public selectionSettings?: object;

    public ngOnInit(): void {
        this.data = editingData;
        this.taskSettings = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            endDate: 'EndDate',
            duration: 'Duration',
            progress: 'Progress',
            dependency: 'Predecessor',
            child: 'subtasks',
        };
        this.selectionSettings = {
            mode: 'Row',
            type: 'Multiple',
        };
    }

    public created(args:object): void {
        this.ganttObj.treeGrid.grid.selectionSettings.enableSimpleMultiRowSelection = false;
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Get selected row information

To access selected row details in the Angular Gantt Chart component:

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { GanttComponent, GanttModule, SelectionService, SelectionSettingsModel } from '@syncfusion/ej2-angular-gantt';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, GanttModule, ButtonModule],
  providers: [SelectionService],
  encapsulation: ViewEncapsulation.None,
  template: `
    <div class="button-container">
      <button ejs-button cssClass="action-button" (click)="getSelectedRowInfo()">Show Selected Tasks</button>
    </div>
    <div class="table-container">
      <table *ngIf="selectedRecords.length > 0" class="task-table">
        <thead>
          <tr>
            <th>Index</th>
            <th>Task Details</th>
          </tr>
        </thead>
        <tbody>
          <tr *ngFor="let record of selectedRecords; let i = index" [ngClass]="{'selected-row': true, 'alternate-row': i % 2 !== 0}">
            <td></td>
            <td>
              <div><strong>Task ID:</strong> </div>
              <div><strong>Task Name:</strong> </div>
              <div><strong>Start Date:</strong> </div>
              <div><strong>Duration:</strong> </div>
              <div><strong>Progress:</strong> %</div>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
    <ejs-gantt #gantt height="430px" [dataSource]="data" [taskFields]="taskSettings" [selectionSettings]="selectionSettings">
    </ejs-gantt>
  `,
  styleUrls: ['./app.component.css']
})

export class AppComponent implements OnInit {
  @ViewChild('gantt', { static: true }) public ganttInstance!: GanttComponent;
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};
  public selectedRowIndexes: number[] = [];
  public selectedRecords: Task[] = [];

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'), Progress: 0 },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019'), Progress: 0 },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 50 }
    ];

    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      endDate: 'EndDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };

    this.selectionSettings = {
      mode: 'Row',
      type: 'Multiple'
    };
  }

  public getSelectedRowInfo(): void {
    // Get selected rows and apply custom style.
    this.selectedRecords = this.ganttInstance.selectionModule.getSelectedRecords() as Task[];
    this.selectedRowIndexes = this.ganttInstance.selectionModule.getSelectedRowIndexes();
    const selectedRows = this.ganttInstance.selectionModule.getSelectedRows() as HTMLElement[];

    // Apply custom-selected-row class to currently selected rows.
    selectedRows.forEach(row => row.classList.add('custom-selected-row'));
  }
}

interface Task {
  TaskID: number;
  TaskName: string;
  StartDate: Date;
  EndDate?: Date;
  Duration?: number;
  Progress?: number;
  ParentID?: number;
}
.button-container {
      padding: 20px 0;
    }

    .action-button {
      background: linear-gradient(90deg, #1e3a8a, #3b82f6);
      color: #ffffff;
      padding: 12px 24px;
      border: none;
      border-radius: 6px;
      font-size: 16px;
      font-weight: 600;
      cursor: pointer;
      transition: all 0.3s ease;
      box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
    }

    .action-button:hover {
      background: linear-gradient(90deg, #1e40af, #60a5fa);
      transform: scale(1.05);
    }

    .action-button:active {
      transform: scale(0.95);
      box-shadow: 0 1px 2px rgba(0, 0, 0, 0.2);
    }

    .action-button:focus {
      outline: none;
      box-shadow: 0 0 0 3px rgba(59, 130, 246, 0.3);
    }

    .table-container {
      display: flex;
      justify-content: center;
      margin-bottom: 20px;
    }

    .task-table {
      border-collapse: collapse;
      width: 80%;
      max-width: 900px;
      font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
      box-shadow: 0 2px 8px rgba(0, 0, 0, 0.1);
    }

    .task-table th, .task-table td {
      padding: 12px 16px;
      text-align: left;
      border: 1px solid #e5e7eb;
    }

    .task-table th {
      background: #f3f4f6;
      font-weight: 600;
      color: #1f2937;
    }

    .selected-row {
      background: #eff6ff;
      transition: background 0.2s ease;
    }

    .alternate-row {
      background: #f9fafb;
    }

    .task-table td div {
      margin-bottom: 6px;
      color: #1f2937;
    }
      
    .e-gantt .e-grid .custom-selected-row .e-selectionbackground {
      background-color: #d1e7dd !important;
    }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Note: The Gantt Chart component supports keyboard navigation for row selection. Use arrow keys to move focus and Enter or Space to select rows. Ensure accessibility compliance by providing appropriate ARIA attributes.

Customize row selection action

You can customize row selection in the Gantt Chart using rowSelecting, rowSelected, rowDeselecting, and rowDeselected events, which allow dynamic control over selection behavior based on specific conditions.

The following demonstrates how row selection and background color updates are handled in the Angular Gantt Chart component:

  • In rowSelecting, selection is prevented when TaskID is 2.
  • In rowSelected, rows with Progress > 40 are highlighted with a green background.
  • In rowDeselected, rows with Progress ≤ 40 are styled with mauve background color.
  • In rowDeselecting, if Progress > 80, the background color changes to yellow.

The following sample demonstrates

import { Component, OnInit, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { GanttComponent, GanttModule, RowDeselectEventArgs, RowSelectEventArgs, RowSelectingEventArgs, SelectionService, SelectionSettingsModel } from '@syncfusion/ej2-angular-gantt';
import { ButtonModule } from '@syncfusion/ej2-angular-buttons';


@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, GanttModule, ButtonModule],
  providers: [SelectionService],
  encapsulation: ViewEncapsulation.None,
  template: `
    <p id="message" *ngIf="showMessage"></p>
    <ejs-gantt #gantt id="ganttDefault" height="370px" [dataSource]="data" [taskFields]="taskSettings" (rowSelected)="rowSelected($event)" (rowSelecting)="rowSelecting($event)" (rowDeselected)="rowDeselected($event)" (rowDeselecting)="rowDeselecting($event)" [selectionSettings]="selectionSettings" enableHover="false">
    </ejs-gantt>`
})

export class AppComponent implements OnInit {
  @ViewChild('gantt', { static: true }) public ganttInstance!: GanttComponent;
  public data: object[] = [];
  public taskSettings: object = {};
  public selectionSettings: SelectionSettingsModel = {};
  public showMessage = false;
  public message = '';

  ngOnInit(): void {
    this.data = [
      { TaskID: 1, TaskName: 'Project Initiation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 50 },
      { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 60 },
      { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, ParentID: 1, Progress: 30 },
      { TaskID: 5, TaskName: 'Project Estimation', StartDate: new Date('04/02/2019'), EndDate: new Date('04/21/2019') },
      { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 90 },
      { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 30 },
      { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, ParentID: 5, Progress: 80 }
    ];
    this.taskSettings = {
      id: 'TaskID',
      name: 'TaskName',
      startDate: 'StartDate',
      endDate: 'EndDate',
      duration: 'Duration',
      progress: 'Progress',
      parentID: 'ParentID'
    };
    this.selectionSettings = {
      mode: 'Row',
      type: 'Multiple'
    };
  }

  public rowSelecting(args: RowSelectingEventArgs): void {
    const task = args.data as Task;
    this.showMessage = true;
    if (task.TaskID === 2) {
      args.cancel = true;
      this.message += ' - Selection cancelled for TaskID 2';
    }
  }

  public rowSelected(args: RowSelectEventArgs): void {
    const task = args.data as Task;
    if (task.Progress && task.Progress > 40) {
      (args.row as HTMLElement).style.backgroundColor = 'rgba(203, 246, 205, 1)';
    }
  }

  public rowDeselected(args: RowDeselectEventArgs): void {
    if (args.data && !Array.isArray(args.data)) {
      const task = args.data as Task;
      if (task.Progress && task.Progress <= 40) {
        (args.row as HTMLElement).style.backgroundColor = '#e1838eff';
      }
    }
  }

  public rowDeselecting(args: RowDeselectEventArgs): void {
    if (args.data && !Array.isArray(args.data)) {
      const task = args.data as Task;
      if (task.Progress && task.Progress > 80) {
        (args.row as HTMLElement).style.backgroundColor = '#f5f54bff';
      }
    }
  }
}

interface Task {
  TaskID: number;
  TaskName: string;
  StartDate: Date;
  EndDate?: Date;
  Duration?: number;
  Progress?: number;
  ParentID?: number;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Row Selection in Vue Gantt Chart Component

18 Nov 201824 minutes to read

The row selection in the Gantt Chart component can be enabled or disabled using the allowSelection property. You can get the selected row object using the getSelectedRecords method. The following code example shows how to disable row selection in Gantt.

<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :allowSelection='false'></ejs-gantt>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { GanttComponent as EjsGantt, Selection } from "@syncfusion/ej2-vue-gantt";
const data = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
        ]
    },
    {
        TaskID: 5,
        TaskName: 'Project Estimation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
        ]
    },
];
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
provide('gantt',  [ Selection ]);
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :allowSelection='false'></ejs-gantt>
    </div>
</template>
<script>

import { GanttComponent, Selection } from "@syncfusion/ej2-vue-gantt";

export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                    { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
                ]
            },
        ],
            height: '450px',
            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                dependency: 'Predecessor',
                child: 'subtasks'
            }
      };
  },
  provide: {
      gantt: [ Selection ]
  }
};
</script>

Row selection is the default type of Gantt selection mode.

Selecting a row on initial load

You can select a row at the time of loading by setting the index of the row to the selectedRowIndex property. The following code example shows the details.

<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :selectedRowIndex = '5' :taskFields = "taskFields" :height = "height"></ejs-gantt>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { GanttComponent as EjsGantt, Selection } from "@syncfusion/ej2-vue-gantt";
const data = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
        ]
    },
    {
        TaskID: 5,
        TaskName: 'Project Estimation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
        ]
    },
];
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
provide('gantt',  [ Selection ]);
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :selectedRowIndex = '5' :taskFields = "taskFields" :height = "height"></ejs-gantt>
    </div>
</template>
<script>
import { GanttComponent, Selection } from "@syncfusion/ej2-vue-gantt";
export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                    { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
                ]
            },
        ],
            height: '450px',
            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                dependency: 'Predecessor',
                child: 'subtasks'
            },
      };
  },
  provide: {
      gantt: [ Selection ]
  }
};
</script>

Selecting a row dynamically

You can select a single row dynamically using the selectRow method. Similarly, you can use the selectRows method to dynamically select multiple rows. The following code demonstrates how to select a single or multiple rows dynamically by clicking a custom button.

<template>
     <div>
        <ejs-button id="selectRow" cssClass="e-info" v-on:click="select">Select Row</ejs-button>
        <ejs-button id="selectRows" cssClass="e-info" v-on:click="Multiselect">Select Multiple Rows</ejs-button>
        <br>
        <br>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" ></ejs-gantt>
    </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { GanttComponent as EjsGantt, Selection } from "@syncfusion/ej2-vue-gantt";
import { ButtonComponent as EjsButton } from "@syncfusion/ej2-vue-buttons";
const gantt = ref(null);
const data = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
        ]
    },
    {
        TaskID: 5,
        TaskName: 'Project Estimation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
        ]
    },
];
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
const select = function(e){
    var ganttObj = gantt.value.ej2Instances;
    ganttObj.selectionModule.selectRow(2); // passing the record index to select the row
}
const Multiselect = function(e){
    var ganttObj = gantt.value.ej2Instances;
     ganttObj.selectionModule.selectRows([1, 2, 3]); // passing the record index to select the rows
}
provide('gantt',  [ Selection ]);
</script>
<template>
     <div>
        <ejs-button id="selectRow" cssClass="e-info" v-on:click="select">Select Row</ejs-button>
        <ejs-button id="selectRows" cssClass="e-info" v-on:click="Multiselect">Select Multiple Rows</ejs-button>
        <br>
        <br>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" ></ejs-gantt>
    </div>
</template>
<script>

import { GanttComponent, Selection } from "@syncfusion/ej2-vue-gantt";
import { ButtonComponent } from "@syncfusion/ej2-vue-buttons";
export default {
name: "App",
components: {
"ejs-button":ButtonComponent,
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                    { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
                ]
            },
        ],
            height: '450px',
            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                dependency: 'Predecessor',
                child: 'subtasks'
            },
            selectionSettings: {
                mode: 'Row',
                type: 'Multiple'
            }
      };
  },
  provide: {
      gantt: [ Selection ]
  },
  methods: {
      select: function(e){
          var ganttObj = document.getElementById('GanttContainer').ej2_instances[0];
          ganttObj.selectionModule.selectRow(2); // passing the record index to select the row
      },
      Multiselect: function(e){
          var ganttObj = document.getElementById('GanttContainer').ej2_instances[0];
           ganttObj.selectionModule.selectRows([1, 2, 3]); // passing the record index to select the rows
      },
  }
};
</script>

Multiple row selection

You can select multiple rows by setting the selectionSettings.type property to multiple. You can select more than one row by holding down the CTRL key while selecting rows. The following code example explains how to enable multiple row selection in Gantt.

<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :selectionSettings="selectionSettings"></ejs-gantt>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { GanttComponent as EjsGantt, Selection } from "@syncfusion/ej2-vue-gantt";
const data = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
        ]
    },
    {
        TaskID: 5,
        TaskName: 'Project Estimation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
        ]
    },
];
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
const selectionSettings = {
    mode: 'Row',
    type: 'Multiple',
}
provide('gantt',  [ Selection ]);
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :selectionSettings="selectionSettings"></ejs-gantt>
    </div>
</template>
<script>

import { GanttComponent, Selection } from "@syncfusion/ej2-vue-gantt";
export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                    { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
                ]
            },
        ],
            height: '450px',
            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                dependency: 'Predecessor',
                child: 'subtasks'
            },
            selectionSettings: {
                mode: 'Row',
                type: 'Multiple',
            }
      };
  },
  provide: {
      gantt: [ Selection ]
  }
};
</script>

Customize row selection action

While selecting a row in Gantt, the rowSelecting and rowSelected events will be triggered. The rowSelecting event is triggered when row selection begins, and you can get the previously selected row and the currently selecting row information, which can be used to prevent the selection of a specific row. The rowSelected event is triggered after the row selection is completed, and you can get the currently selected row information through this event. The following code example demonstrates how to prevent the selection of a row using the rowSelecting event.

<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :rowSelecting="rowSelecting" :selectionSettings="selectionSettings"></ejs-gantt>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { GanttComponent as EjsGantt, Selection } from "@syncfusion/ej2-vue-gantt";
const data = [
    {
        TaskID: 1,
        TaskName: 'Project Initiation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
            { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
            { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
        ]
    },
    {
        TaskID: 5,
        TaskName: 'Project Estimation',
        StartDate: new Date('04/02/2019'),
        EndDate: new Date('04/21/2019'),
        subtasks: [
            { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
            { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
        ]
    },
];
const height = '450px';
const taskFields = {
    id: 'TaskID',
    name: 'TaskName',
    startDate: 'StartDate',
    endDate: 'EndDate',
    duration: 'Duration',
    progress: 'Progress',
    dependency: 'Predecessor',
    child: 'subtasks'
};
const rowSelecting = function (args) {
    if (args.data.TaskID == 4) {
        args.cancel = true;
    }
};
const selectionSettings = {
    mode: 'Row',
}
provide('gantt',  [ Selection ]);
</script>
<template>
     <div>
        <ejs-gantt ref='gantt' id="GanttContainer" :dataSource="data" :taskFields = "taskFields" :height = "height" :rowSelecting="rowSelecting" :selectionSettings="selectionSettings"></ejs-gantt>
    </div>
</template>
<script>

import { GanttComponent, Selection } from "@syncfusion/ej2-vue-gantt";

export default {
name: "App",
components: {
"ejs-gantt":GanttComponent
},
  data: function() {
      return{
            data: [
            {
                TaskID: 1,
                TaskName: 'Project Initiation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    {  TaskID: 2, TaskName: 'Identify Site location', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                    { TaskID: 3, TaskName: 'Perform Soil test', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50  },
                    { TaskID: 4, TaskName: 'Soil test approval', StartDate: new Date('04/02/2019'), Duration: 4, Progress: 50 },
                ]
            },
            {
                TaskID: 5,
                TaskName: 'Project Estimation',
                StartDate: new Date('04/02/2019'),
                EndDate: new Date('04/21/2019'),
                subtasks: [
                    { TaskID: 6, TaskName: 'Develop floor plan for estimation', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 7, TaskName: 'List materials', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 },
                    { TaskID: 8, TaskName: 'Estimation approval', StartDate: new Date('04/04/2019'), Duration: 3, Progress: 50 }
                ]
            },
        ],
            height: '450px',
            taskFields: {
                id: 'TaskID',
                name: 'TaskName',
                startDate: 'StartDate',
                endDate: 'EndDate',
                duration: 'Duration',
                progress: 'Progress',
                dependency: 'Predecessor',
                child: 'subtasks'
            },
            rowSelecting: function (args) {
                if (args.data.TaskID == 4) {
                    args.cancel = true;
                }
            },
            selectionSettings: {
                mode: 'Row'
            }
      };
  },
  provide: {
      gantt: [ Selection ]
  }
};
</script>

In the Gantt Chart component, when you click an already selected row, the selection will be cleared. While deselecting a row in Gantt, the rowDeselecting and rowDeselected events will be triggered. The rowDeselecting event occurs when row deselection begins, and you can get the currently deselecting row’s information to prevent the deselection of a particular row. The rowDeselected event occurs when the row deselection action is completed, and you can get the currently deselected row’s information.